文档章节

6个常见的 PHP 安全性攻击

久一网络
 久一网络
发布于 2015/10/22 06:50
字数 1407
阅读 13
收藏 0
了解常见的PHP应用程序安全威胁,可以确保你的PHP应用程序不受攻击。因此,本文将列出 6个常见的 PHP 安全性攻击,欢迎大家来阅读和学习。 

1、SQL注入  

SQL注入是一种恶意攻击,用户利用在表单字段输入SQL语句的方式来影响正常的SQL执行。还有一种是通过system()或exec()命令注入的,它具有相同的SQL注入机制,但只针对shell命令。 

?
1
2
3
4
5
6
7
8
9
10
$username=$_POST['username'];
$query="select * from auth where username = '".$username."'";
echo$query;
$db=newmysqli('localhost','demo', ‘demo', ‘demodemo');
$result=$db->query($query);
if($result&&$result->num_rows) {
    echo"<br />Logged in successfully";
}else{
    echo"<br />Login failed";
}

上面的代码,在第一行没有过滤或转义用户输入的值($_POST['username'])。因此查询可能会失败,甚至会损坏数据库,这要看$username是否包含变换你的SQL语句到别的东西上。 

防止SQL注入  

选项:  
  • 使用mysql_real_escape_string()过滤数据
  • 手动检查每一数据是否为正确的数据类型
  • 使用预处理语句并绑定变量

使用准备好的预处理语句  
  • 分离数据和SQL逻辑
  • 预处理语句将自动过滤(如:转义)
  • 把它作为一个编码规范,可以帮助团队里的新人避免遇到以上问题

?
1
2
3
4
5
6
7
8
9
10
11
12
13
$query='select name, district from city where countrycode=?';
if($stmt=$db->prepare($query) )
{
    $countrycode='hk';
    $stmt->bind_param("s",$countrycode); 
    $stmt->execute();
    $stmt->bind_result($name,$district);
    while($stmt($stmt->fetch() ){
       echo$name.', '.$district;
       echo'<br />';
    }
    $stmt->close();
}

2、XSS攻击  

XSS(跨站点脚本攻击)是一种攻击,由用户输入一些数据到你的网站,其中包括客户端脚本(通常JavaScript)。如果你没有过滤就输出数据到另一个web页面,这个脚本将被执行。 

接收用户提交的文本内容 
?
1
2
3
4
5
6
7
8
9
10
11
12
<?php
if(file_exists('comments')) {
    $comments= get_saved_contents_from_file('comments');
}else{
    $comments='';
}
 
if(isset($_POST['comment'])) {
    $comments.='<br />'.$_POST['comment'];
    save_contents_to_file('comments',$comments);
}
>

输出内容给(另一个)用户 
?
1
2
3
4
5
6
7
<form action='xss.php'method='POST'>
Enter your comments here: <br />
<textarea name='comment'></textarea> <br />
<input type='submit'value='Post comment'/>
</form><hr /><br />
 
<?phpecho$comments; ?>

将会发生什么事?  
  • 烦人的弹窗
  • 刷新或重定向
  • 损坏网页或表单
  • 窃取cookie
  • AJAX(XMLHttpRequest)

防止XSS攻击  

为了防止XSS攻击,使用PHP的htmlentities()函数过滤再输出到浏览器。htmlentities()的基本用法很简单,但也有许多高级的控制,请参阅  XSS速查表 。 

3、会话固定  

会话安全,假设一个PHPSESSID很难猜测。然而,PHP可以接受一个会话ID通过一个Cookie或者URL。因此,欺骗一个受害者可以使用一个特定的(或其他的)会话ID 或者钓鱼攻击。 

 

4、会议捕获和劫持  

这是与会话固定有着同样的想法,然而,它涉及窃取会话ID。如果会话ID存储在Cookie中,攻击者可以通过XSS和JavaScript窃取。如果会话ID包含在URL上,也可以通过嗅探或者从代理服务器那获得。 

防止会话捕获和劫持  
  • 更新ID
  • 如果使用会话,请确保用户使用SSL

5、跨站点请求伪造(CSRF)  

CSRF攻击,是指一个页面发出的请求,看起来就像是网站的信任用户,但不是故意的。它有许多的变体,比如下面的例子: 
?
1
<imgsrc='http://example.com/single_click_to_buy.php?user_id=123&item=12345'>

防止跨站点请求伪造  

一般来说,确保用户来自你的表单,并且匹配每一个你发送出去的表单。有两点一定要记住: 
  1. 对用户会话采用适当的安全措施,例如:给每一个会话更新id和用户使用SSL。
  2. 生成另一个一次性的令牌并将其嵌入表单,保存在会话中(一个会话变量),在提交时检查它。

6、代码注入  

代码注入是利用计算机漏洞通过处理无效数据造成的。问题出在,当你不小心执行任意代码,通常通过文件包含。写得很糟糕的代码可以允许一个远程文件包含并执行。如许多PHP函数,如require可以包含URL或文件名,例如: 

?
1
2
3
4
5
6
7
8
9
10
11
12
13
<form>Choose theme:
    <select name = theme>
       <option value = blue>Blue</option>
       <option value = green>Green</option>
       <option value = red>Red</option>
    </select>
    <input type = submit>
</form>
<?php
    if($theme) {
       require($theme.'.txt');
    }
?>

在上面的例子中,通过传递用户输入的一个文件名或文件名的一部分,来包含以"http://"开头的文件。 

防止代码注入  
  • 过滤用户输入
  • 在php.ini中设置禁用allow_url_fopen和allow_url_include。这将禁用require/include/fopen的远程文件。
  
其他的一般原则  

1. 不要依赖服务器配置来保护你的应用,特别是当你的web服务器/ PHP是由你的ISP管理,或者当你的网站可能迁移/部署到别处,未来再从别处迁移/部署在到其他地方。请在网站代码中嵌入带有安全意识的检查/逻辑(HTML、JavaScript、PHP,等等)。   
2. 设计服务器端的安全脚本: 
—例如,使用单行执行 - 单点身份验证和数据清理   
—例如,在所有的安全敏感页面嵌入一个PHP函数/文件,用来处理所有登录/安全性逻辑检查 
3. 确保你的代码更新,并打上最新补丁。 
  

英文原文 , OSChina.NET翻译

本文转载自:http://www.oschina.net/question/157182_65350?sort=time&p=2#tags_nav

共有 人打赏支持
久一网络
粉丝 0
博文 34
码字总数 22404
作品 0
杭州
个人站长
私信 提问

暂无文章

Ubuntu16.04下安装docker

[TOC] 本文开发环境为Ubuntu 16.04 LTS 64位系统,通过apt的docker官方源安装最新的Docker CE(Community Edition),即Docker社区版,是开发人员和小型团队的理想选择。 1. 开始安装 1.1 由于...

豫华商
今天
10
0
使用XShell工具密钥认证登录Linux系统

如果你是一名Linux运维,那么Linux服务器的系统安全问题,可能是你要考虑的,而系统登录方式有两种,密码和密钥。哪一种更加安全呢? 无疑是后者! 这里我为大家分享用Xshell利器使用密钥的方...

dragon_tech
今天
8
0
day178-2018-12-15-英语流利阅读-待学习

“真蛛奶茶”了解一下?蜘蛛也会产奶了 Lala 2018-12-15 1.今日导读 “蛋白质含量是牛奶的 4 倍,并有着更低的脂肪和含糖量”,听起来诱人又美味的并不是羊奶或豆奶,而是你可能打死都想不到...

飞鱼说编程
今天
12
0
npm WARN optional SKIPPING OPTIONAL DEPENDENCY: fsevents

场景重现 npm install --verbose 安装依赖的时,出现如下警告 npm WARN optional SKIPPING OPTIONAL DEPENDENCY: fsevents@1.2.4 (node_modules\fsevents):npm WARN notsup SKIPPING OPTIONA......

taadis
今天
2
0
OSChina 周六乱弹 —— 你一口我一口多咬一口是小狗

Osc乱弹歌单(2018)请戳(这里) 【今日歌曲】 @达尔文 :分享Roy Orbison的单曲《She's a Mystery to Me》 《She's a Mystery to Me》- Roy Orbison 手机党少年们想听歌,请使劲儿戳(这里...

小小编辑
今天
495
6

没有更多内容

加载失败,请刷新页面

加载更多

返回顶部
顶部